(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["FluxHelpers"] = factory();
	else
		root["FluxHelpers"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _helpers = __webpack_require__(/*! ./helpers */ 2);
	
	var _helpers2 = _interopRequireDefault(_helpers);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	module.exports = _helpers2.default;

/***/ },
/* 1 */
/*!*******************************!*\
  !*** ./src/generate-token.js ***!
  \*******************************/
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	function randomInt(low, high) {
	  return Math.floor(Math.random() * (high - low) + low);
	}
	
	// Based on https://developer.mozilla.org/en-US/docs/Web/API/WindowBase64/Base64_encoding_and_decoding
	/* eslint-disable */
	function b64EncodeUnicode(str) {
	  return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, function (match, p1) {
	    return String.fromCharCode('0x' + p1);
	  }));
	}
	/* eslint-enable */
	
	function generateToken() {
	  var crypto = window.crypto || window.msCrypto;
	  var randomNumbers = null;
	
	  if (crypto && crypto.getRandomValues && window.Uint32Array) {
	    randomNumbers = crypto.getRandomValues(new Uint32Array(4));
	  } else {
	    // This method (including randomInt above) is based on
	    // https://blog.tompawlak.org/generate-random-values-nodejs-javascript
	    randomNumbers = [];
	
	    for (var i = 0; i < 36; i++) {
	      randomNumbers.push(randomInt(0, 10));
	    }
	  }
	
	  return b64EncodeUnicode(randomNumbers.join('')).slice(0, 48).replace(/\+|\/]/g, '0');
	}
	
	exports.default = generateToken;

/***/ },
/* 2 */
/*!************************!*\
  !*** ./src/helpers.js ***!
  \************************/
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	var _storage = __webpack_require__(/*! ./storage */ 3);
	
	var _generateToken = __webpack_require__(/*! ./generate-token */ 1);
	
	var _generateToken2 = _interopRequireDefault(_generateToken);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var STATE_KEY = 'state';
	var NONCE_KEY = 'nonce';
	var CREDENTIALS_KEY = 'credentials';
	
	// Lightweight check: has the user just been redirected from authenticating at Flux?
	// The implicit OIDC flow will stick access_token (among other things) in URL hash.
	function isLoggingIn() {
	  return window.location.hash.search(/access_token/) !== -1;
	}
	
	var FluxHelpers = function () {
	  function FluxHelpers(sdk) {
	    _classCallCheck(this, FluxHelpers);
	
	    if (!sdk) {
	      throw new Error('Must supply an SDK');
	    }
	
	    this._sdk = sdk;
	  }
	
	  _createClass(FluxHelpers, [{
	    key: 'redirectToFluxLogin',
	    value: function redirectToFluxLogin(replace) {
	      // We clear up local storage in case there's a lingering user in there.
	      (0, _storage.clear)();
	
	      var state = (0, _generateToken2.default)();
	      var nonce = (0, _generateToken2.default)();
	
	      (0, _storage.store)(STATE_KEY, state);
	      (0, _storage.store)(NONCE_KEY, nonce);
	
	      var url = this._sdk.getAuthorizeUrl(state, nonce);
	
	      // We need to assign and call the redirect function like this, or the browser
	      // may throw an error due to special window.location behaviour.
	      var redirect = replace ? 'replace' : 'assign';
	      window.location[redirect](url);
	    }
	  }, {
	    key: 'storeFluxUser',
	    value: function storeFluxUser(redirectUrl, replace) {
	      var _this = this;
	
	      var promise = null;
	
	      if (!isLoggingIn()) {
	        promise = Promise.resolve();
	      } else {
	        (function () {
	          var state = (0, _storage.retrieve)(STATE_KEY);
	          var nonce = (0, _storage.retrieve)(NONCE_KEY);
	
	          // As above, we need to assign and call the redirect function specially or the browser
	          // may throw an error due to special window.location behaviour.
	          var redirect = replace ? 'replace' : 'assign';
	          var url = redirectUrl || window.location.href.replace(window.location.hash, '');
	
	          if (!state) {
	            throw new Error('No `state` stored');
	          } else if (!nonce) {
	            throw new Error('No `nonce` stored');
	          }
	
	          promise = _this._sdk.exchangeCredentials(state, nonce).then(function (credentials) {
	            // We clear here to get rid of the now-unneeded `state` and `nonce` values,
	            // as well as anything else that might be lingering in storage.
	            (0, _storage.clear)();
	
	            (0, _storage.store)(CREDENTIALS_KEY, credentials);
	          }).then(function () {
	            window.location[redirect](url);
	          });
	        })();
	      }
	
	      return promise;
	    }
	  }, {
	    key: 'isLoggedIn',
	    value: function isLoggedIn() {
	      var credentials = (0, _storage.retrieve)(CREDENTIALS_KEY);
	
	      return this._sdk.User.isLoggedIn(credentials).then(function (loggedIn) {
	        if (!loggedIn) {
	          // We clear the credentials key in case invalid (e.g., expired) credentials are
	          // still in there.
	          (0, _storage.clear)(CREDENTIALS_KEY);
	        }
	
	        return loggedIn;
	      });
	    }
	  }, {
	    key: 'logout',
	    value: function logout() {
	      // So long and thanks for all the fish!
	      (0, _storage.clear)();
	    }
	  }, {
	    key: 'getUser',
	    value: function getUser() {
	      var credentials = (0, _storage.retrieve)(CREDENTIALS_KEY);
	
	      if (!credentials) {
	        throw new Error('Cannot get current user: No user credentials stored');
	      }
	
	      return this._sdk.getUser(credentials);
	    }
	
	    /* eslint-disable consistent-return */
	
	  }, {
	    key: 'login',
	    value: function login(redirectUrl, replace) {
	      if (!isLoggingIn()) {
	        // We don't return anything here because the user is synchronously redirected,
	        // interrupting the current browser execution.
	        this.redirectToFluxLogin(replace);
	      } else {
	        return this.storeFluxUser(redirectUrl, replace);
	      }
	    }
	    /* eslint-enable consistent-return */
	
	  }]);
	
	  return FluxHelpers;
	}();
	
	exports.default = FluxHelpers;

/***/ },
/* 3 */
/*!************************!*\
  !*** ./src/storage.js ***!
  \************************/
/***/ function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	var STORAGE_KEY = '__FLUX__';
	
	function retrieve(key) {
	  var fluxStore = JSON.parse(window.localStorage.getItem(STORAGE_KEY)) || {};
	
	  return key ? fluxStore[key] || null : fluxStore;
	}
	
	function store(key, value) {
	  var fluxStore = retrieve();
	  fluxStore[key] = value;
	
	  window.localStorage.setItem(STORAGE_KEY, JSON.stringify(fluxStore));
	}
	
	function clear(key) {
	  if (key) {
	    var stored = retrieve();
	    delete stored[key];
	
	    if (Object.keys(stored).length) {
	      window.localStorage.setItem(STORAGE_KEY, JSON.stringify(stored));
	    } else {
	      window.localStorage.removeItem(STORAGE_KEY);
	    }
	  } else {
	    window.localStorage.removeItem(STORAGE_KEY);
	  }
	}
	
	exports.retrieve = retrieve;
	exports.store = store;
	exports.clear = clear;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=flux-sdk-helpers.js.map