'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var STORAGE_KEY = '__FLUX__';

function retrieve(key) {
  var fluxStore = JSON.parse(window.localStorage.getItem(STORAGE_KEY)) || {};

  return key ? fluxStore[key] || null : fluxStore;
}

function store(key, value) {
  var fluxStore = retrieve();
  fluxStore[key] = value;

  window.localStorage.setItem(STORAGE_KEY, JSON.stringify(fluxStore));
}

function clear(key) {
  if (key) {
    var stored = retrieve();
    delete stored[key];

    if (Object.keys(stored).length) {
      window.localStorage.setItem(STORAGE_KEY, JSON.stringify(stored));
    } else {
      window.localStorage.removeItem(STORAGE_KEY);
    }
  } else {
    window.localStorage.removeItem(STORAGE_KEY);
  }
}

exports.retrieve = retrieve;
exports.store = store;
exports.clear = clear;
//# sourceMappingURL=storage.js.map